Attribute VB_Name = "modGraphics"
'
'  Wall of the Words is Copyright (c) 2008 Robson
'
'  This program is free software; you can redistribute it and/or modify
'  it under the terms of the GNU General Public License as published by
'  the Free Software Foundation; either version 2 of the License, or
'  (at your option) any later version.
'
'  This program is distributed in the hope that it will be useful, but
'  WITHOUT ANY WARRANTY; without even the implied warranty of
'  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'  General Public License for more details.
'
'  The license can be viewed at http://www.gnu.org/licenses/gpl.html
'
' all variables are declared
Option Explicit

Public Declare Function TransparentBlt Lib "msimg32" (ByVal hDCDest As Long, ByVal nXOriginDest As Long, _
  ByVal nYOriginDest As Long, ByVal nWidthDest As Long, ByVal nHeightDest As Long, ByVal hDCSrc As Long, _
  ByVal nXOriginSrc As Long, ByVal nYOriginSrc As Long, ByVal nWidthSrc As Long, ByVal nHeightSrc As Long, _
  ByVal crTransparent As Long) As Long

Public arrTileList() As New StdPicture
Public Const TILE_GRASS As Byte = 1
Public Const TILE_CASTLEWALLUP As Byte = 2
Public Const TILE_MUD As Byte = 3
Public Const TILE_ENEMY_SOLDIER As Byte = 4
Public Const TILE_DEFENCEWALL As Byte = 5
Public Const TILE_TREE As Byte = 6
Public Const TILE_WATER As Byte = 7
Public Const TILE_SCROLL As Byte = 8
Public Const TILE_HIT_MINOR As Byte = 9
Public Const TILE_HIT_MAJOR As Byte = 10

Public Sub LoadTiles()
    ReDim arrTileList(10)
    Set arrTileList(TILE_GRASS) = LoadPicture(App.Path & "\images\grass.gif")
    Set arrTileList(TILE_CASTLEWALLUP) = LoadPicture(App.Path & "\images\castle_wall_up.gif")
    Set arrTileList(TILE_MUD) = LoadPicture(App.Path & "\images\mud.gif")
    Set arrTileList(TILE_ENEMY_SOLDIER) = LoadPicture(App.Path & "\images\enemy_soldier.gif")
    Set arrTileList(TILE_DEFENCEWALL) = LoadPicture(App.Path & "\images\defence_wall.gif")
    Set arrTileList(TILE_TREE) = LoadPicture(App.Path & "\images\tree.gif")
    Set arrTileList(TILE_WATER) = LoadPicture(App.Path & "\images\water.gif")
    Set arrTileList(TILE_SCROLL) = LoadPicture(App.Path & "\images\scroll.gif")
    Set arrTileList(TILE_HIT_MINOR) = LoadPicture(App.Path & "\images\hit_minor.gif")
    Set arrTileList(TILE_HIT_MAJOR) = LoadPicture(App.Path & "\images\hit_major.gif")
End Sub

Public Sub DrawBattlefield()
    Dim X As Integer, Y As Integer
    Dim blnEffects As Boolean
    For X = 0 To UBound(arrBattlefield, 1)
        For Y = 0 To UBound(arrBattlefield, 2)
            With arrBattlefield(X, Y)
                If .blnDefenceWall Then
                    frmMain.PaintPicture arrTileList(TILE_DEFENCEWALL), X * 32, Y * 32
                    frmMain.DrawWidth = 2
                    frmMain.ForeColor = RGB(100, 100, 100)
                    If X > 0 Then
                        If Not arrBattlefield(X - 1, Y).blnDefenceWall Then
                            frmMain.Line (X * 32, Y * 32)-(X * 32, (Y + 1) * 32)
                        End If
                    End If
                    If Y > 0 Then
                        If Not arrBattlefield(X, Y - 1).blnDefenceWall Then
                            frmMain.Line ((X * 32) - 1, Y * 32)-((X + 1) * 32, Y * 32)
                        End If
                    End If
                    frmMain.ForeColor = RGB(25, 25, 25)
                    If Not arrBattlefield(X + 1, Y).blnDefenceWall Then
                        frmMain.Line (((X + 1) * 32) - 1, Y * 32)-(((X + 1) * 32) - 1, (Y + 1) * 32)
                    End If
                    If Not arrBattlefield(X, Y + 1).blnDefenceWall Then
                        frmMain.Line (X * 32, ((Y + 1) * 32) - 1)-((X + 1) * 32, ((Y + 1) * 32) - 1)
                    End If
                    frmMain.ForeColor = vbWhite
                    frmMain.Font.Name = "Georgia"
                    frmMain.Font.Size = 17
                    frmMain.CurrentX = (X * 32) + (16 - (frmMain.TextWidth(.strLetter) / 2))
                    frmMain.CurrentY = (Y * 32) + 1
                    frmMain.Print .strLetter
                    If .intHitPoints <= 2 Then
                        frmMain.ForeColor = RGB(255, 50, 0)
                    Else
                        frmMain.ForeColor = vbYellow
                    End If
                    frmMain.Font.Size = 7
                    frmMain.Font.Name = "Tahoma"
                    frmMain.CurrentX = ((X + 1) * 32) - (frmMain.TextWidth(CStr(.intHitPoints)) + 6)
                    frmMain.CurrentY = ((Y + 1) * 32) - (frmMain.TextHeight("A") + 1)
                    frmMain.Print .intHitPoints
                ElseIf .blnEnemy Then
                    frmMain.picDraw.Picture = arrTileList(TILE_ENEMY_SOLDIER)
                    frmMain.PaintPicture arrTileList(TILE_GRASS), X * 32, Y * 32
                    TransparentBlt frmMain.hDC, X * 32, Y * 32, 32, 32, frmMain.picDraw.hDC, 0, 0, 32, 32, frmMain.picDraw.Point(0, 0)
                    Box X, Y
                ElseIf .blnWater Then
                    frmMain.picDraw.Picture = arrTileList(TILE_WATER)
                    frmMain.PaintPicture arrTileList(TILE_GRASS), X * 32, Y * 32
                    TransparentBlt frmMain.hDC, X * 32, Y * 32, 32, 32, frmMain.picDraw.hDC, 0, 0, 32, 32, frmMain.picDraw.Point(0, 0)
                    Box X, Y
                ElseIf .blnTree Then
                    frmMain.picDraw.Picture = arrTileList(TILE_TREE)
                    frmMain.PaintPicture arrTileList(TILE_GRASS), X * 32, Y * 32
                    TransparentBlt frmMain.hDC, X * 32, Y * 32, 32, 32, frmMain.picDraw.hDC, 0, 0, 32, 32, frmMain.picDraw.Point(0, 0)
                    Box X, Y
                ElseIf .blnGrass Then
                    frmMain.PaintPicture arrTileList(TILE_GRASS), X * 32, Y * 32
                    Box X, Y
                ElseIf .blnCastleWall Then
                    frmMain.PaintPicture arrTileList(TILE_CASTLEWALLUP), X * 32, Y * 32
                ElseIf .blnCastleMud Then
                    frmMain.PaintPicture arrTileList(TILE_MUD), X * 32, Y * 32
                End If
                If .blnDefenceWallTemporary Then
                    frmMain.DrawWidth = 2
                    frmMain.ForeColor = vbWhite
                    frmMain.Line ((X * 32) + 3, (Y * 32) + 3)-(((X + 1) * 32) - 4, ((Y + 1) * 32) - 4), , B
                    frmMain.ForeColor = vbWhite
                    frmMain.Font.Name = "Georgia"
                    frmMain.Font.Size = 17
                    frmMain.CurrentX = (X * 32) + (15 - (frmMain.TextWidth(.strLetter) / 2))
                    frmMain.CurrentY = (Y * 32) + 1
                    frmMain.Print .strLetter
                End If
                If .blnAffected Then
                    frmMain.DrawWidth = 2
                    frmMain.ForeColor = vbWhite
                    frmMain.Line ((X * 32) + 3, (Y * 32) + 3)-((X * 32) + 4, (Y * 32) + 4), , BF
                End If
                If .blnHitMinor Then
                    frmMain.picDraw.Picture = arrTileList(TILE_HIT_MINOR)
                    TransparentBlt frmMain.hDC, (X * 32) + RNG(-5, 5), (Y * 32) + RNG(-5, 5), 32, 32, frmMain.picDraw.hDC, 0, 0, 32, 32, frmMain.picDraw.Point(0, 0)
                    blnEffects = True
                    .blnHitMinor = False
                End If
                If .blnHitMajor Then
                    frmMain.picDraw.Picture = arrTileList(TILE_HIT_MAJOR)
                    TransparentBlt frmMain.hDC, X * 32, Y * 32, 32, 32, frmMain.picDraw.hDC, 0, 0, 32, 32, frmMain.picDraw.Point(0, 0)
                    blnEffects = True
                    .blnHitMajor = False
                End If
            End With
        Next
    Next
    frmMain.Caption = App.ProductName & " -- Level " & bytLevel & " of 3 / Turn " & intTurn & " of " & bytTurnRetreat & " / Score " & lngScore
    DrawLetters
    DoEvents
    If blnEffects Then
        Dim J As Double
        J = Timer
        Do
        Loop Until Timer - J > 0.75
        DrawBattlefield
    End If
End Sub

Public Sub Box(ByVal X As Byte, ByVal Y As Byte)
    frmMain.ForeColor = RGB(0, 110, 0)
    frmMain.DrawWidth = 1
    frmMain.Line ((X + 1) * 32, (Y + 1) * 32)-(((X + 1) * 32) - 1, Y * 32), , B
    frmMain.Line ((X + 1) * 32, (Y + 1) * 32)-(X * 32, ((Y + 1) * 32) - 1), , B
End Sub

Public Sub Status(ByVal strMessage As String)
    frmMain.lblStatus.Caption = strMessage
End Sub

Public Sub DrawWelcome()
    Dim X As Integer, Y As Integer
    With frmMain
        For X = 1 To .ScaleWidth Step 32
            For Y = 1 To .ScaleHeight Step 32
                .PaintPicture arrTileList(TILE_GRASS), X, Y
            Next
        Next
    End With
    
    Dim R As Byte, G As Byte, B As Byte
    R = RNG(125, 254)
    G = RNG(125, 254)
    B = RNG(125, 254)
    With frmMain
        .BackColor = RGB(R, G, B)
        For X = -.ScaleHeight To .ScaleWidth + .ScaleHeight Step 8
            If RNG(0, 1) = 0 Then
                .ForeColor = RGB(R * 0.9, G * 0.9, B * 0.9)
            Else
                .ForeColor = RGB(R * 1.05, G * 1.05, B * 1.05)
            End If
            .DrawWidth = RNG(1, 3)
            frmMain.Line (X, 0)-(X + .ScaleHeight, .ScaleHeight)
            If RNG(0, 1) = 0 Then
                .ForeColor = RGB(R * 0.9, G * 0.9, B * 0.9)
            Else
                .ForeColor = RGB(R * 1.05, G * 1.05, B * 1.05)
            End If
            .DrawWidth = RNG(1, 3)
            frmMain.Line (X + .ScaleHeight, 0)-(X, .ScaleHeight)
        Next
        .DrawWidth = 1
    End With
    
    bytLetterPoints(Asc("a") - Asc("a")) = 1
    bytLetterPoints(Asc("d") - Asc("a")) = 4
    bytLetterPoints(Asc("e") - Asc("a")) = 1
    bytLetterPoints(Asc("f") - Asc("a")) = 4
    bytLetterPoints(Asc("h") - Asc("a")) = 4
    bytLetterPoints(Asc("l") - Asc("a")) = 3
    bytLetterPoints(Asc("o") - Asc("a")) = 1
    bytLetterPoints(Asc("r") - Asc("a")) = 2
    bytLetterPoints(Asc("s") - Asc("a")) = 2
    bytLetterPoints(Asc("t") - Asc("a")) = 2
    bytLetterPoints(Asc("w") - Asc("a")) = 5

    DrawWords "wall of", 32 * 2
    DrawWords "the words", 32 * 3.5
    
End Sub

Private Sub DrawWords(ByVal strWords As String, ByVal Y As Integer)
    Dim N As Integer, X As Integer
    For N = 1 To Len(strWords)
        If Mid(strWords, N, 1) <> " " Then
            With frmMain
                X = ((.ScaleWidth / 2) - ((Len(strWords) * 35)) / 2) + ((N - 1) * 35)
                .PaintPicture arrTileList(TILE_DEFENCEWALL), X, Y
                .DrawWidth = 2
                .ForeColor = RGB(100, 100, 100)
                frmMain.Line (X + 1, Y + 0)-(X + 1, Y + 31)
                frmMain.Line (X + 0, Y + 1)-(X + 31, Y + 1)
                .ForeColor = RGB(25, 25, 25)
                frmMain.Line (X + 31, Y + 2)-(X + 31, Y + 31)
                frmMain.Line (X + 2, Y + 31)-(X + 31, Y + 31)
                .ForeColor = vbYellow
                .Font.Size = 7
                .Font.Name = "Tahoma"
                .CurrentX = (X + 32) - (frmMain.TextWidth("A") + 6)
                .CurrentY = (Y + 32) - (frmMain.TextHeight("A") + 1)
                frmMain.Print bytLetterPoints(Asc(LCase(Mid(strWords, N, 1))) - Asc("a"))
                .ForeColor = vbWhite
                .Font.Name = "Georgia"
                .Font.Size = 17
                .CurrentX = (X + 16) - (frmMain.TextWidth(Mid(strWords, N, 1)) / 2)
                .CurrentY = Y + 1
                frmMain.Print Mid(strWords, N, 1)
                .DrawWidth = 1
            End With
        End If
    Next
End Sub

Public Sub DrawLetters()
    Dim N As Byte
    For N = 0 To frmMain.picLetter.UBound
        frmMain.picLetter(N).Top = frmMain.ScaleHeight - (frmMain.picLetter(N).Height + 7)
        frmMain.picLetter(N).Visible = N <= UBound(arrLetters)
        If N <= UBound(arrLetters) Then
            With frmMain.picLetter(N)
                If blnLettersInUse(N) Then
                    .Cls
                    .BackColor = vbBlack
                Else
                    .PaintPicture arrTileList(TILE_DEFENCEWALL), 0, 0
                    .DrawWidth = 2
                    .ForeColor = RGB(100, 100, 100)
                    frmMain.picLetter(N).Line (1, 0)-(1, 32)
                    frmMain.picLetter(N).Line (0, 1)-(32, 1)
                    .ForeColor = RGB(25, 25, 25)
                    frmMain.picLetter(N).Line (31, 2)-(31, 32)
                    frmMain.picLetter(N).Line (2, 31)-(32, 31)
                End If
                .ForeColor = vbYellow
                .Font.Size = 7
                .Font.Name = "Tahoma"
                .CurrentX = 32 - (frmMain.picLetter(N).TextWidth("A") + 6)
                .CurrentY = 32 - (frmMain.picLetter(N).TextHeight("A") + 1)
                frmMain.picLetter(N).Print bytLetterPoints(Asc(arrLetters(N)) - Asc("a"))
                .ForeColor = vbWhite
                .Font.Name = "Georgia"
                .Font.Size = 17
                .CurrentX = 16 - (frmMain.picLetter(N).TextWidth(arrLetters(N)) / 2)
                .CurrentY = 1
                frmMain.picLetter(N).Print arrLetters(N)
            End With
        End If
    Next
    frmMain.lblStatus.Left = frmMain.picLetter(UBound(arrLetters)).Left + frmMain.picLetter(0).Width + 8
    frmMain.lblStatus.Width = frmMain.ScaleWidth - (frmMain.lblStatus.Left + 8)
    frmMain.lblStatus.Top = frmMain.picLetter(0).Top
    With frmMain.picLetterNew
        .Top = frmMain.picLetter(0).Top
        .Visible = True
        .PaintPicture arrTileList(TILE_SCROLL), 0, 0
    End With
End Sub
