Attribute VB_Name = "modWordList"
'
'  Wall of the Words is Copyright (c) 2008 Robson
'
'  This program is free software; you can redistribute it and/or modify
'  it under the terms of the GNU General Public License as published by
'  the Free Software Foundation; either version 2 of the License, or
'  (at your option) any later version.
'
'  This program is distributed in the hope that it will be useful, but
'  WITHOUT ANY WARRANTY; without even the implied warranty of
'  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'  General Public License for more details.
'
'  The license can be viewed at http://www.gnu.org/licenses/gpl.html
'
' all variables are declared
Option Explicit

Public strWords() As String
Public bytLetterPoints(25) As Byte
Public lngLetterStartPositions(25) As Long
Dim lngLetterFrequency(25) As Long
Dim lngTotalCharacters As Long

Public Sub MakeInitialLetters()
    ReDim arrLetters(frmMain.picLetter.UBound)
    ReDim blnLettersInUse(UBound(arrLetters))
    ' ohhh noes, more stupidly named variables
    Dim A As Integer, B As Integer, C As Byte, D As Byte
    Dim dblRandomPercent As Double
    Dim dblCurrentPercent As Double
    For A = 0 To UBound(arrLetters)
        dblRandomPercent = RNG(0, 10000) / 100
        dblCurrentPercent = 0
        For B = 0 To 25
            dblCurrentPercent = dblCurrentPercent + ((lngLetterFrequency(B) / lngTotalCharacters) * 100)
            If dblCurrentPercent > dblRandomPercent Then
                C = 0
                For D = 0 To A
                    If arrLetters(D) = Chr(Asc("a") + B) Then
                        C = C + 1
                    End If
                Next
                If C > RNG(0, 2) Then
                    A = A - 1
                Else
                    arrLetters(A) = Chr(Asc("a") + B)
                End If
                Exit For
            End If
        Next
        ' uh oh
        If Trim(arrLetters(A)) = "" Then
            arrLetters(A) = "e"
        End If
    Next
End Sub

Public Sub ReplaceUsedLetters()
    Dim A As Integer, B As Integer, C As Byte, D As Byte
    Dim dblRandomPercent As Double
    Dim dblCurrentPercent As Double
    For A = 0 To UBound(arrLetters)
        If blnLettersInUse(A) Then
            frmMain.picLetter(A).DragMode = 1
            dblRandomPercent = RNG(0, 10000) / 100
            dblCurrentPercent = 0
            For B = 0 To 25
                dblCurrentPercent = dblCurrentPercent + ((lngLetterFrequency(B) / lngTotalCharacters) * 100)
                If dblCurrentPercent > dblRandomPercent Then
                    C = 0
                    For D = 0 To UBound(arrLetters)
                        If Not blnLettersInUse(D) Then
                            If arrLetters(D) = Chr(Asc("a") + B) Then
                                C = C + 1
                            End If
                        End If
                    Next
                    If C > RNG(0, 2) Then
                        A = A - 1
                    Else
                        arrLetters(A) = Chr(Asc("a") + B)
                    End If
                    Exit For
                End If
            Next
        End If
    Next
    For A = 0 To UBound(blnLettersInUse)
        blnLettersInUse(A) = False
    Next
End Sub

' this code is responsible for grabbing all the words from the wordlist.txt file.
' it also stores the position where each first letter changes
Public Sub LoadWordList()
    Dim strLine As String, strStartLetter As String
    Dim N As Long, A As Long, X As Long
    Dim lngAll As Long
    ReDim strWords(350000)
    lngAll = (FileLen(App.Path & "\wordlist.txt") * 0.82)
    frmMain.Font.Size = 10
    frmMain.CurrentX = 3
    frmMain.CurrentY = 2
    frmMain.ForeColor = vbBlack
    frmMain.Print "version 1.0.1"
    frmMain.CurrentX = frmMain.ScaleWidth - (frmMain.TextWidth("by robson") + 3)
    frmMain.CurrentY = 2
    frmMain.Print "by robson"
    frmMain.CurrentX = (frmMain.ScaleWidth / 2) - (frmMain.TextWidth("abcdefghijklmnopqrstuvwxyz") / 2)
    frmMain.CurrentY = frmMain.ScaleHeight - 20
    frmMain.ForeColor = vbWhite
    frmMain.Print "abcdefghijklmnopqrstuvwxyz"
    frmMain.CurrentX = (frmMain.ScaleWidth / 2) - (frmMain.TextWidth("abcdefghijklmnopqrstuvwxyz") / 2)
    frmMain.ForeColor = vbBlack
    Open App.Path & "\wordlist.txt" For Input As #1
    While Not EOF(1)
        Line Input #1, strWords(N)
        CountLetters strWords(N)
        ' check if the current word starts with a different letter to the previous word
        If strStartLetter <> Left(strWords(N), 1) Then
            lngLetterStartPositions(Asc(Left(strWords(N), 1)) - Asc("a")) = N
            strStartLetter = Left(strWords(N), 1)
            frmMain.CurrentY = frmMain.ScaleHeight - 20
            X = frmMain.CurrentX
            frmMain.Print strStartLetter
            frmMain.CurrentX = X + frmMain.TextWidth(strStartLetter)
            frmMain.Refresh
        End If
        N = N + 1
        ' if we've entered a word into the end of the array
        If UBound(strWords) < N Then
            ' make the array bigger
            ReDim Preserve strWords(UBound(strWords) + 1000)
        End If
    Wend
    Close #1
    ' make the array as big as the word list
    ReDim Preserve strWords(N - 1)
    ' get total letter count
    lngTotalCharacters = 0
    For N = 0 To 25
        lngTotalCharacters = lngTotalCharacters + lngLetterFrequency(N)
    Next
    For N = 0 To 25
        Select Case (lngLetterFrequency(N) / lngTotalCharacters) * 100
            Case Is > 7.5
                bytLetterPoints(N) = 1
            Case Is > 6
                bytLetterPoints(N) = 2
            Case Is > 3.25
                bytLetterPoints(N) = 3
            Case Is > 2
                bytLetterPoints(N) = 4
            Case Is > 1.25
                bytLetterPoints(N) = 5
            Case Is > 0.5
                bytLetterPoints(N) = 6
            Case Is > 0.25
                bytLetterPoints(N) = 7
            Case Else
                bytLetterPoints(N) = 8
        End Select
    Next
    With frmMain
        .Font.Size = 12
        .Font.Italic = True
        .Font.Bold = True
        .CurrentY = .ScaleHeight - 40
        .CurrentX = (.ScaleWidth / 2) - (.TextWidth("click to play") / 2)
        .ForeColor = vbBlack
        frmMain.Print "click to play"
        .Font.Italic = False
        .Font.Bold = False
        'frmmain.Line (.ScaleWidth * 0.35, .ScaleHeight - 20)-((.ScaleWidth * 0.35) + ((.ScaleWidth * 0.3) * 1), .ScaleHeight - 10), , BF
    End With
End Sub

Private Sub CountLetters(ByVal strWord As String)
    Dim N As Byte
    For N = 1 To Len(strWord)
        lngLetterFrequency(Asc(Mid(strWord, N, 1)) - Asc("a")) = lngLetterFrequency(Asc(Mid(strWord, N, 1)) - Asc("a")) + 1
    Next
End Sub

Public Function InWordList(ByVal strWord As String) As Boolean
    strWord = LCase(strWord)
    ' make sure the word begins with a letter
    If Asc(Left(strWord, 1)) >= Asc("a") And Asc(Left(strWord, 1)) <= Asc("z") Then
        Dim N As Long
        ' we only check words that match the first letter.
        ' so tree is only compared against words that are t*
        ' this code gets the start and end places to check
        Dim lngStart As Long, lngEnd As Long
        lngStart = lngLetterStartPositions(Asc(Left(strWord, 1)) - Asc("a"))
        If Left(strWord, 1) = "z" Then
            ' z has no letter after it, so we just use the end of the array
            lngEnd = UBound(strWords)
        Else
            ' check until we get to words starting with the next letter
            lngEnd = lngLetterStartPositions((Asc(Left(strWord, 1)) - Asc("a")) + 1)
        End If
        ' now see if the word is in this part of the array
        For N = lngStart To lngEnd
            If strWord = strWords(N) Then
                InWordList = True
                Exit Function
            End If
        Next
    End If
End Function

Public Sub DetermineHitPoints()
    Dim X As Integer, Y As Integer
    Dim A As Integer, B As Integer
    Dim blnConnected As Boolean
    Dim intCount As Integer, intPoints As Integer
    Dim blnUp As Boolean, blnDown As Boolean, blnLeft As Boolean, blnRight As Boolean
    For X = 0 To UBound(arrBattlefield, 1)
        For Y = 0 To UBound(arrBattlefield, 2)
            arrBattlefield(X, Y).blnAffected = False
        Next
    Next
    For X = 0 To UBound(arrBattlefield, 1)
        For Y = 0 To UBound(arrBattlefield, 2)
            If arrBattlefield(X, Y).blnDefenceWallTemporary Then
                If Not arrBattlefield(X, Y).blnAffected Then
                    arrBattlefield(X, Y).blnAffected = True
                    intCount = intCount + 1
                    intPoints = intPoints + arrBattlefield(X, Y).intHitPoints
                End If
                blnUp = False
                blnDown = False
                blnLeft = False
                blnRight = False
                A = X + 1
                Do While A <= UBound(arrBattlefield, 1)
                    If arrBattlefield(A, Y).blnDefenceWall Or arrBattlefield(A, Y).blnDefenceWallTemporary Then
                        If Not arrBattlefield(A, Y).blnAffected Then
                            If arrBattlefield(A, Y).blnDefenceWall Then
                                blnConnected = True
                            End If
                            arrBattlefield(A, Y).blnAffected = True
                            intCount = intCount + 1
                            intPoints = intPoints + arrBattlefield(A, Y).intHitPoints
                        End If
                        blnDown = True
                    Else
                        Exit Do
                    End If
                    A = A + 1
                Loop
                A = X - 1
                Do While A >= 0
                    If arrBattlefield(A, Y).blnDefenceWall Or arrBattlefield(A, Y).blnDefenceWallTemporary Then
                        If Not arrBattlefield(A, Y).blnAffected Then
                            If arrBattlefield(A, Y).blnDefenceWall Then
                                blnConnected = True
                            End If
                            arrBattlefield(A, Y).blnAffected = True
                            intCount = intCount + 1
                            intPoints = intPoints + arrBattlefield(A, Y).intHitPoints
                        End If
                        blnDown = True
                    Else
                        Exit Do
                    End If
                    A = A - 1
                Loop
                A = Y + 1
                Do While A <= UBound(arrBattlefield, 2)
                    If arrBattlefield(X, A).blnDefenceWall Or arrBattlefield(X, A).blnDefenceWallTemporary Then
                        If Not arrBattlefield(X, A).blnAffected Then
                            If arrBattlefield(X, A).blnDefenceWall Then
                                blnConnected = True
                            End If
                            arrBattlefield(X, A).blnAffected = True
                            intCount = intCount + 1
                            intPoints = intPoints + arrBattlefield(X, A).intHitPoints
                        End If
                        blnDown = True
                    Else
                        Exit Do
                    End If
                    A = A + 1
                Loop
                A = Y - 1
                Do While A >= 0
                    If arrBattlefield(X, A).blnDefenceWall Or arrBattlefield(X, A).blnDefenceWallTemporary Then
                        If Not arrBattlefield(X, A).blnAffected Then
                            If arrBattlefield(X, A).blnDefenceWall Then
                                blnConnected = True
                            End If
                            arrBattlefield(X, A).blnAffected = True
                            intCount = intCount + 1
                            intPoints = intPoints + arrBattlefield(X, A).intHitPoints
                        End If
                        blnDown = True
                    Else
                        Exit Do
                    End If
                    A = A - 1
                Loop
                If (blnUp And (blnRight Or blnLeft)) Or (blnDown And (blnRight Or blnLeft)) Then
                    intCount = intCount + 1
                    intPoints = intPoints + arrBattlefield(X, Y).intHitPoints
                End If
            End If
        Next
    Next
    Dim intAverage As Integer
    Dim strScore As String
    strScore = "Letter points (" & intPoints & ")"
    If blnConnected Then
        strScore = strScore & " + Is connected (" & Int(intPoints / 2) & ")"
        intPoints = intPoints + Int(intPoints / 2)
    End If
    intPoints = intPoints + (intCount * 2)
    strScore = strScore & " + Tiles affected (" & intCount & "*2)"
    intAverage = Round(intPoints / intCount, 0)
    For X = 0 To UBound(arrBattlefield, 1)
        For Y = 0 To UBound(arrBattlefield, 2)
            With arrBattlefield(X, Y)
                If .blnAffected Then
                    If .intHitPoints < intAverage Then
                        .intHitPoints = intAverage
                    End If
                End If
            End With
        Next
    Next
    Status strScore & " = " & intPoints & " points"
    lngScore = lngScore + intPoints
End Sub

Public Function CheckWords() As Boolean
    Dim X As Integer, Y As Integer, A As Integer, S As Integer
    Dim strSequences() As String
    Dim blnValid As Boolean
    Dim arrChars() As String
    ReDim strSequences(0)
    ReDim arrChars(UBound(arrBattlefield, 1), UBound(arrBattlefield, 2))
    For X = 0 To UBound(arrBattlefield, 1)
        For Y = 0 To UBound(arrBattlefield, 2)
            If arrBattlefield(X, Y).blnDefenceWallTemporary Then
                arrChars(X, Y) = arrBattlefield(X, Y).strLetter
                For A = X To 0 Step -1
                    If arrBattlefield(A, Y).blnDefenceWall Or arrBattlefield(A, Y).blnDefenceWallTemporary Then
                        arrChars(A, Y) = arrBattlefield(A, Y).strLetter
                    Else
                        Exit For
                    End If
                Next
                For A = X To UBound(arrBattlefield, 1)
                    If arrBattlefield(A, Y).blnDefenceWall Or arrBattlefield(A, Y).blnDefenceWallTemporary Then
                        arrChars(A, Y) = arrBattlefield(A, Y).strLetter
                    Else
                        Exit For
                    End If
                Next
                For A = Y To 0 Step -1
                    If arrBattlefield(X, A).blnDefenceWall Or arrBattlefield(X, A).blnDefenceWallTemporary Then
                        arrChars(X, A) = arrBattlefield(X, A).strLetter
                    Else
                        Exit For
                    End If
                Next
                For A = Y To UBound(arrBattlefield, 2)
                    If arrBattlefield(X, A).blnDefenceWall Or arrBattlefield(X, A).blnDefenceWallTemporary Then
                        arrChars(X, A) = arrBattlefield(X, A).strLetter
                    Else
                        Exit For
                    End If
                Next
            End If
        Next
    Next
    For X = 0 To UBound(arrChars, 1) - 1
        For Y = 0 To UBound(arrChars, 2)
            blnValid = False
            If X = 0 Then
                blnValid = arrChars(X, Y) <> vbNullString And arrChars(X + 1, Y) <> vbNullString
            Else
                blnValid = arrChars(X - 1, Y) = vbNullString And arrChars(X, Y) <> vbNullString And arrChars(X + 1, Y) <> vbNullString
            End If
            If blnValid Then
                ReDim Preserve strSequences(UBound(strSequences) + 1)
                For A = X To UBound(arrChars, 1)
                    If arrChars(A, Y) <> vbNullString Then
                        strSequences(UBound(strSequences)) = strSequences(UBound(strSequences)) & arrChars(A, Y)
                    Else
                        Exit For
                    End If
                Next
            End If
        Next
    Next
    For Y = 0 To UBound(arrChars, 2) - 1
        For X = 0 To UBound(arrChars, 1)
            blnValid = False
            If Y = 0 Then
                blnValid = arrChars(X, Y) <> vbNullString And arrChars(X, Y + 1) <> vbNullString
            Else
                blnValid = arrChars(X, Y - 1) = vbNullString And arrChars(X, Y) <> vbNullString And arrChars(X, Y + 1) <> vbNullString
            End If
            If blnValid Then
                ReDim Preserve strSequences(UBound(strSequences) + 1)
                For A = Y To UBound(arrChars, 2)
                    If arrChars(X, A) <> vbNullString Then
                        strSequences(UBound(strSequences)) = strSequences(UBound(strSequences)) & arrChars(X, A)
                    Else
                        Exit For
                    End If
                Next
            End If
        Next
    Next
    Dim bytNeighbours As Byte
    For X = 0 To UBound(arrChars, 1)
        For Y = 0 To UBound(arrChars, 2)
            If arrChars(X, Y) <> vbNullString Then
                bytNeighbours = 0
                If X > 0 Then
                    If arrChars(X - 1, Y) <> vbNullString Then
                        bytNeighbours = bytNeighbours + 1
                    End If
                End If
                If X < UBound(arrChars, 1) Then
                    If arrChars(X + 1, Y) <> vbNullString Then
                        bytNeighbours = bytNeighbours + 1
                    End If
                End If
                If Y > 0 Then
                    If arrChars(X, Y - 1) <> vbNullString Then
                        bytNeighbours = bytNeighbours + 1
                    End If
                End If
                If Y < UBound(arrChars, 2) Then
                    If arrChars(X, Y + 1) <> vbNullString Then
                        bytNeighbours = bytNeighbours + 1
                    End If
                End If
                If bytNeighbours = 0 Then
                    Status "''" & arrChars(X, Y) & "'' isn't allowed. Words must have at least two letters"
                    Exit Function
                End If
            End If
        Next
    Next
    CheckWords = True
    For X = 1 To UBound(strSequences)
        If Not InWordList(strSequences(X)) Then
            Status "''" & strSequences(X) & "'' isn't on the word list"
            CheckWords = False
            Exit Function
        End If
    Next
End Function
